<?php

/*
 =========================================================================
 |   Copyright 2006 - Andrei Dumitrache. All rights reserved.
 |    http://hogsmeade-village.com
 |
 |   This file is part of Xpression News (X-News).
 |
 |   Xpression News is free software; you can redistribute it and/or modify
 |   it under the terms of the GNU General Public License as published by
 |   the Free Software Foundation; either version 2 of the License, or
 |   (at your option) any later version.
 |
 |   Xpression News is distributed in the hope that it will be useful,
 |   but WITHOUT ANY WARRANTY; without even the implied warranty of
 |   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 |   GNU General Public License for more details.
 |
 |   You should have received a copy of the GNU General Public License
 |   along with Xpression News; if not, write to the Free Software
 |   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 |
 |   ALSO
 |
 |   [--] You are not allowed to sell or claim any part of this publication to be yours
 |   [--] You are not allowed to remove or alter our hyperlink from the files where it is
 |        included (news.php, archives.php and index.php)
 |   [--] You must agree to this license agreement to use the script in any way.
 =========================================================================
*/

$steps = array(1 => "user",2=> "script_settings",3=> "news_publishing", 4=> "news_comments", 5=> "image_manager", 6=> "rss_engine");
$lang="English";


function LanguageField($field,$lang)
{
   $language_file=$script['paths']['file']."language/".$lang."/language_cp.php";
   include($language_file);
   return $lng[$field];
}

echo "dupa1\n";

function GenerateLanguageMenu($lang)
{
	$language_root="language/";
	$handle=dir($language_root);
	$code='';
	while (false !== ($item = $handle->read()))
	{
		$language_dir=$language_root.$item;
		if (is_dir($language_dir) && $item!='.' && $item!='..')
		{
			if ($item==$lang)
			{
				$code.='<option selected value="'.$item.'">'.$item.'</option>';
			}else
			{
				$code.='<option value="'.$item.'">'.$item.'</option>';
			}
		}
	}
	$handle->close();
	return $code;
}

echo "dupa2\n";

function ApplyLanguage($input,$lang)
{
	$language_file=$script['paths']['file']."language/$lang/language_cp.php";
	include($language_file);
	$lang_keys=array_keys($lng);
	foreach ($lang_keys as $lang_key)
	{
		$rep='$__'.$lang_key;
		$dat=urldecode($lng[$lang_key]);
		$input=str_replace($rep,$dat,$input);
	}
	$input=str_replace(base64_decode("eyRMSUN9"),"",$input);
	return $input;
}

echo "dupa3\n";

$file="inc/wrapper.html";
// odczyt pliku 
$f = fopen($file, 'r');
$wrapper = fread($f, filesize($file));
fclose($f);

echo "dupa3.1\n";

$file="inc/install.html";
// odczyt pliku 
$f = fopen($file, 'r');
$page = fread($f, filesize($file));
fclose($f);

echo "dupa3.2\n";

if (!is_writable('userdb.php')){$err.='|userdb.php';}
if (!is_writable('config.inc.php')){$err.='|config.inc.php';}
if (!is_writable('configuration')){$err.='|configuration';}
if (isset($err))
{
	echo "dupa3.5\n";
    $page="<div align=\"center\" class=\"SpanClass1\"><font color=\"#D20000\">You must set full writing permissions to the X-News folder and to ALL its files to continue with the setup wizard.</font></div>";
    $wrapper=str_replace('{PAGE}',$page,$wrapper);
    $wrapper=str_replace('{USER_NICK}',"",$wrapper);
    $wrapper=str_replace('{USER_NAME}',"",$wrapper);
    $wrapper=str_replace('{LABEL_LOGGED_IN_AS}','',$wrapper);
    $wrapper=str_replace('{LABEL_LOGOUT}','',$wrapper);
    $wrapper=ApplyLanguage($wrapper,$lang);
    print $wrapper;
    exit;
	echo "dupa3.9\n";
}

echo "dupa4\n";

$action=$_GET['a'];
$target=$_GET['t'];

if (!isset($action))
{
	echo "dupa5\n";
	//========================================================================
	// Checking if the x-news folder is writable. If not, display warning and
	// pause the install process.
	//========================================================================
	header("Location: install.php?a=view&t=user");
}
else if ($action=="view")
{
	echo "dupa6\n";
	$target=$_GET['t'];
	if ($target=="user")
	{
		echo "dupa7\n";
		if (file_exists("userdb.php"))
		{
			echo "dupa8\n";
			$content=file("userdb.php");
			if (count($content)>1){header("Location: install.php?a=view&t=script_settings");}
		}
	}
	
	echo "dupa8.1\n";
	$file="inc/wrapper.html";
	// odczyt pliku 
	$f = fopen($file, 'r');
	$wrapper = fread($f, filesize($file));
	fclose($f);
	
	echo "dupa8.2\n";
	
	$file="inc/install.html";
	// odczyt pliku 
	$f = fopen($file, 'r');
	$page = fread($f, filesize($file));
	fclose($f);
	
	echo "dupa8.3\n";
	
	$wrapper=str_replace('{PAGE}',$page,$wrapper);
	$wrapper=str_replace('{USER_NICK}',"",$wrapper);
	$wrapper=str_replace('{USER_NAME}',"",$wrapper);
	$wrapper=str_replace('{LABEL_LOGGED_IN_AS}','',$wrapper);
	$wrapper=str_replace('{LABEL_LOGOUT}','',$wrapper);
	$wrapper=ApplyLanguage($wrapper,$lang);

	echo "dupa8.4\n";

	$file="inc/install_$target.html";
	// odczyt pliku 
	$f = fopen($file, 'r');
	$page = fread($f, filesize($file));
	fclose($f);

	echo "dupa8.5\n";

	$wrapper=str_replace('{SETUPTAB}',$page,$wrapper);
	echo "dupa8.6\n";
	if ($target!="user" and $target!="completed")
	{
		echo "dupa9\n";
		require("configuration/$target.php");
		require("configuration/$target.inc.php");
		$path=__FILE__;
		$path=substr($path,0,strlen($path)-11);
		$path=str_replace("\\","/",$path);
		$url="http://".$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
		$url=substr($url,0,strrpos($url,"/")+1);
		if (empty($script['paths']['file'])){$wrapper=str_replace("paths|file",$path,$wrapper);}
		if (empty($script['paths']['url'])){$wrapper=str_replace("paths|url",$url,$wrapper);}
		if (empty($script['paths']['newsurl'])){$wrapper=str_replace("paths|newsurl",$url."news.php",$wrapper);}
		if (empty($script['icons']['path'])){$wrapper=str_replace("icons|path",$path."icons/",$wrapper);}
		if (empty($script['icons']['url'])){$wrapper=str_replace("icons|url",$url."icons/",$wrapper);}
		if (empty($script['images']['picturedir'])){$wrapper=str_replace("paths|picturedir",$path."images/",$wrapper);}
		if (empty($script['images']['pictureurl'])){$wrapper=str_replace("paths|pictureurl",$url."images/",$wrapper);}
		if (empty($script['images']['picviewer'])){$wrapper=str_replace("paths|picviewer",$url."viewer.php?src=",$wrapper);}
		if (empty($script['rss']['link'])){$wrapper=str_replace("rss|link",$url."news.php",$wrapper);}

		if ($target!="news_publishing"){$wrapper=ReadConfiguration($wrapper);}else
		{
			echo "dupa10\n";
			$optcode="<option value=\"newest\" selected>".LanguageField("l_newest",$lang)."</option><option value=\"oldest\">".LanguageField("l_oldest",$lang)."</option>";
			$wrapper=str_replace("news|sort",$optcode,$wrapper);
		}
		$menu=GenerateLanguageMenu($lang);
		$wrapper=str_replace("system|language",$menu,$wrapper);

		$keys=array_keys($script);
		foreach ($keys as $i=>$key)
		{
			if (is_array($script[$key]))
			{
				$subkeys=array_keys($script[$key]);
				foreach ($subkeys as $i=>$subkey)
				{
					$wrapper=str_replace($key."|".$subkey,$script[$key][$subkey],$wrapper);
				}
			}else
			{
				$wrapper=str_replace($key."|",$script[$key],$wrapper);
			}
		}
	}
	echo "dupa8.7\n";
	$wrapper=str_replace("check_YES","checked",$wrapper);
	$wrapper=str_replace("check_NO","",$wrapper);
	$wrapper=str_replace("check_ON","checked",$wrapper);
	$wrapper=str_replace("check_OFF","",$wrapper);
	echo "dupa8.8\n";
	print ApplyLanguage($wrapper,$lang);
	echo "dupa8.9\n";
}
else if ($action=="edit")
{
	echo "dupa11.1\n";
	$target=$_GET['t'];
	$goto=$_POST['goto'];
	foreach ($steps as $i=>$step){if ($step==$target){$index=$i;}}
	if ($goto==LanguageField("l_back",$lang))
	{
		$index--;
	}else
	{
		$index++;
	}
	if ($target!="user")
	{
		echo "dupa11.2\n";
		require("configuration/$target.php");
		WriteConfiguration();
	}else
	{
		echo "dupa11.3\n";
		$account=$_POST['accountname'];
		$displayname=$_POST['displayname'];
		$emailaddress=$_POST['emailaddress'];
		$password=md5($_POST['password']);
		$handle=fopen("userdb.php","w");
		$joined=time();
		fwrite($handle,"<?php die(\"Access denied\");?>\n");
		$line="$account|$displayname|$password|1||$emailaddress|$joined|||\n";
		fwrite($handle,$line);
		fclose($handle);
		echo "dupa11.4\n";
	}
	if (empty($steps[$index]))
	{
		echo "dupa12.1\n";
		$buf='<?php
			include("configuration/image_manager.inc.php");
			include("configuration/script_settings.inc.php");
			include("configuration/news_publishing.inc.php");
			include("configuration/news_comments.inc.php");
			include("configuration/rss_engine.inc.php");
		?>
		';
		echo "dupa12.2\n";
		$handle=fopen("config.inc.php","w");
		fwrite($handle,$buf);
		fclose($handle);
		header("Location: install.php?a=view&t=completed");
	} else{
		header("Location: install.php?a=view&t=".$steps[$index]);
	}
}

?>