<?php

/*
 =========================================================================
 |   Copyright 2006 - Andrei Dumitrache. All rights reserved.
 |    http://hogsmeade-village.com
 |
 |   This file is part of Xpression News (X-News).
 |
 |   Xpression News is free software; you can redistribute it and/or modify
 |   it under the terms of the GNU General Public License as published by
 |   the Free Software Foundation; either version 2 of the License, or
 |   (at your option) any later version.
 |
 |   Xpression News is distributed in the hope that it will be useful,
 |   but WITHOUT ANY WARRANTY; without even the implied warranty of
 |   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 |   GNU General Public License for more details.
 |
 |   You should have received a copy of the GNU General Public License
 |   along with Xpression News; if not, write to the Free Software
 |   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 |
 |   ALSO
 |
 |   [--] You are not allowed to sell or claim any part of this publication to be yours
 |   [--] You are not allowed to remove or alter our hyperlink from the files where it is
 |        included (news.php, archives.php and index.php)
 |   [--] You must agree to this license agreement to use the script in any way.
 =========================================================================
*/

function ShowActionPage($actpage)
{
  require("config.inc.php");
  $wrapper=file_get_contents($script['paths']['file']."inc/wrapper.html");
  $page=file_get_contents($script['paths']['file']."inc/".$actpage.".html");
  $wrapper=str_replace('{PAGE}',$page,$wrapper);
  $wrapper=ApplyLanguage($wrapper,"_cp");
  return $wrapper;
}

function ShowActionPage2($actpage)
{
    require_once("functions.php");
    $wrapper=ShowActionPage($actpage);
    $nick=$_COOKIE['xusername'];
    $userinfo=GetUserInfo($nick);
    $wrapper=str_replace('{LABEL_LOGGED_IN_AS}','$__loggedinas',$wrapper);
    $wrapper=str_replace('{LABEL_LOGOUT}','<a href="index.php?a=login">[$__logout]</a>',$wrapper);
    $wrapper=str_replace('{USER_NICK}',$nick,$wrapper);
    $wrapper=str_replace('{USER_NAME}',$userinfo['name'],$wrapper);
    $wrapper=ApplyLanguage($wrapper,"_cp");
    return $wrapper;
}

function ShowMessage($title,$message)
{
   require_once("functions.php");
   $wrapper=ShowActionPage2("message");
   $wrapper=str_replace('{INFO_TITLE}',$title,$wrapper);
   $wrapper=str_replace('{INFO_BODY}',$message,$wrapper);
   $wrapper=ApplyLanguage($wrapper,"_cp");
   return $wrapper;
}

function ShowDlgPage($action,$vars,$postvec)
{
  require("config.inc.php");
  $nick=$_COOKIE['xusername'];
  $userinfo=GetUserInfo($nick);
  $wrapper=file_get_contents($script['paths']['file']."inc/wrapper.html");
  $page=file_get_contents($script['paths']['file']."inc/dlg.html");
  $wrapper=str_replace('{PAGE}',$page,$wrapper);
  $wrapper=str_replace('{FORM_ACTION}',$action,$wrapper);
  $vars=explode(',',$vars);
  $fields='';
  foreach ($vars as $i=>$v)
  {
    $a=$postvec[$v];
    if (is_array($a)==true)
    {
    foreach ($a as $j=>$sv)
    {
     $fields.='<input type="hidden" name="'.$v.'[]" value="'.$sv.'">';

    }}else
    {
     $fields.='<input type="hidden" name="'.$v.'" value="'.$a.'">';
    }
  }
  $wrapper=str_replace("{FIELDS}",$fields,$wrapper);
      $wrapper=str_replace('{LABEL_LOGGED_IN_AS}','Logged in as: ',$wrapper);
      $wrapper=str_replace('{USER_NICK}',$nick,$wrapper);
      $wrapper=str_replace('{USER_NAME}',$userinfo['name'],$wrapper);
      $wrapper=str_replace('{LABEL_LOGOUT}','<a href="index.php?a=login">[Log out]</a>',$wrapper);
      $wrapper=ApplyLanguage($wrapper,"_cp");
  return $wrapper;
}

function ShowInputDlgPage($header,$action,$lbl,$def)
{
  require("config.inc.php");
  $wrapper=file_get_contents($script['paths']['file']."inc/wrapper.html");
  $page=file_get_contents($script['paths']['file']."inc/inputdlg.html");
    $nick=$_COOKIE['xusername'];
    $userinfo=GetUserInfo($nick);
  $wrapper=str_replace('{PAGE}',$page,$wrapper);
  $wrapper=str_replace('{FORM_ACTION}',$action,$wrapper);
  $wrapper=str_replace('{HEADER}',$header,$wrapper);
  $wrapper=str_replace('{LABEL}',$lbl,$wrapper);
  $wrapper=str_replace('{DEF}',$def,$wrapper);
  $wrapper=str_replace('{LABEL_LOGGED_IN_AS}','Logged in as: ',$wrapper);
  $wrapper=str_replace('{LABEL_LOGOUT}','<a href="index.php?a=login">[Log out]</a>',$wrapper);
  $wrapper=str_replace('{USER_NICK}',$nick,$wrapper);
  $wrapper=str_replace('{USER_NAME}',$userinfo['name'],$wrapper);
  $wrapper=ApplyLanguage($wrapper,"_cp");
  return $wrapper;
}



function SkinNewsArticle($article,$tpl)
{
 require("config.inc.php");
 require_once("functions.php");
 if (empty($tpl)){$tpl=file_get_contents($script['paths']['file']."templates/".GetDefaultTemplate()."/news-article.html");}

        $article['date']=DecodeTime($article['date']);
        $c=str_replace('{title}',$article['title'],$tpl);
                $c=ApplyLanguage($c,'');
        $c=str_replace('{article}',$article['short_story'],$c);
        $c=str_replace('{date}',$article['date'],$c);

        if ($article['icon']=='')
        {
         $c=str_replace('{icon}','',$c);
        }else
        {
         $c=str_replace('{icon}','<img src="'.$article['icon'].'" align="left">',$c);
        }

        $authorline='';
        $uinfo=GetUserInfo($article['author']);
        if (!empty($uinfo['email']))
        {
         $authorline='<a href="mailto:'.$uinfo['email'].'">'.$uinfo['name'].'</a>';
        } else {
         $authorline=$uinfo['name'];
        }
        $c=str_replace('{author}',$authorline,$c);
        if ($script['comments']['enabled']=="ON")
        {
         $c=str_replace('{com-link}','<a href="'.$_SERVER['SCRIPT_NAME'].'?xnewsaction=getcomments&amp;newsarch='.$article['archive'].'&amp;newsid='.$article['id'].'">',$c);
         $c=str_replace('{/com-link}','</a>',$c);
        }else
        {
         $c1=substr($c,0,strpos($c,'{com-link}'));
         $c2=substr($c,strpos($c,'{/com-link}')+11);
         $c=$c1.$c2;
        }
        $c=str_replace('{num-com}',NumComments($article['archive'],$article['id']),$c);
        if ($article['full_story']!=''){
         $c=str_replace('{full_news_link}','<a href="'.$_SERVER['SCRIPT_NAME'].'?xnewsaction=fullnews&amp;newsarch='.$article['archive'].'&amp;newsid='.$article['id'].'">',$c);
         $c=str_replace('{/full_news_link}','</a>',$c);
        }else
        {
         $c1=substr($c,0,strpos($c,'{full_news_link}'));
         $c2=substr($c,strpos($c,'{/full_news_link}')+17);
         $c=$c1.$c2;
        }
        $c=str_replace('{newsarch}',$article['archive'],$c);
        $c=str_replace('{newsid}',$article['id'],$c);
        $c=str_replace('{cat-name}',GetCatName($article['cat']),$c);
        $c=str_replace('{cat-id}',$article['cat'],$c);
        $c=str_replace('{self}',$_SERVER['SCRIPT_NAME'],$c);
        return $c;
}
function SkinFullNewsArticle($article,$tpl)
{
        $article['date']=DecodeTime($article['date']);
        $c=str_replace('{title}',$article['title'],$tpl);
        $c=ApplyLanguage($c,'');
        if ($article['full_story']=='')
        {
        $c=str_replace('{article}',$article['short_story'],$c);
        }else
        {
         $c=str_replace('{article}',$article['full_story'],$c);
        }
        $c=str_replace('{date}',$article['date'],$c);
        if ($article['icon']=='')
        {
         $c=str_replace('{icon}','',$c);
        }else
        {
         $c=str_replace('{icon}','<img src="'.$article['icon'].'" align="left">',$c);
        }
        $authorline='';
        $uinfo=GetUserInfo($article['author']);
        if (!empty($uinfo['email']))
        {
         $authorline='<a href="mailto:'.$uinfo['email'].'">'.$uinfo['name'].'</a>';
        } else {
         $authorline=$uinfo['name'];
        }
        $c=str_replace('{author}',$authorline,$c);
        $c=str_replace('{newsarch}',$article['archive'],$c);
        $c=str_replace('{newsid}',$article['id'],$c);
        $c=str_replace('{cat-name}',GetCatName($article['cat']),$c);
        $c=str_replace('{cat-id}',$article['cat'],$c);
        $c=str_replace('{self}',$_SERVER['SCRIPT_NAME'],$c);
        $c=str_replace('{com-link}','<a href="'.$_SERVER['SCRIPT_NAME'].'?xnewsaction=getcomments&amp;newsarch='.$article['archive'].'&amp;newsid='.$article['id'].'">',$c);
        $c=str_replace('{/com-link}','</a>',$c);
        $c=str_replace('{num-com}',NumComments($article['archive'],$article['id']),$c);
   return $c;

}

function GenerateEmoticonList($c,$limit)
{
  require_once("functions.php");
  require("config.inc.php");
  $emos=ListEmoticons();
  if ($limit=="")
  {
   $limit=count($emos);
  }
  $tbl='';
  $c1=0;
  foreach ($emos as $i=>$emo)
  {
    $emname=substr($emo,0,strpos($emo,'.'));
    if ($i>=$limit){break;}
    $emourl=$script['paths']['url']."smillies/".$emo;
    if ($c=="no-link")
    {
    $tbl.='<img src="'.$emourl.'" border="0">';
    }else if ($c=="popup")
    {
      $tbl.='<a href="javascript:InsertEmoticon(\'[::'.$emname.']\');"><img src="'.$emourl.'" border="0"></a> ';
    }else
    {
    $tbl.='<a href="javascript:InsertBBcode'.$c.'(\'[::'.$emname.']\');"><img src="'.$emourl.'" border="0"></a>';
    }
  }
  return $tbl;
}


function SkinCommentsPage($article,$comments,$template,$thispage,$range)
{

   if ($range==''){$range='1-25';}
   require("config.inc.php");
   require_once("functions.php");
   $newsarch=$article['archive'];
   $newsid=$article['id'];
   $wrapper=file_get_contents($script['paths']['file']."templates/$template/comments-wrapper.html");
   $addform=file_get_contents($script['paths']['file']."templates/$template/add-comment.html");
   $commenttpl=file_get_contents($script['paths']['file']."templates/$template/comment.html");
   $newsarticletpl= file_get_contents($script['paths']['file']."templates/$template/news-article.html");
   $fullnewsarticletpl= file_get_contents($script['paths']['file']."templates/$template/full-news-article.html");
   if ($script['comments']['captcha']!="ON")
   {
    $addform1=substr($addform,0,strpos($addform,'<!--BEGIN CAPTCHA//-->'));
    $addform2=substr($addform,strpos($addform,'<!--END CAPTCHA//-->')+20);
    $addform=$addform1.$addform2;
   }else
   {
    $code=GenCaptcha();
    $captchaurl=$script['paths']['url']."captcha/".$_SERVER['REMOTE_ADDR'].".php";
    $addform=str_replace('{CAPTCHAIMAGE}','<img src="'.$captchaurl.'">',$addform);
    $addform=str_replace('{MD5CAPTCHA}',md5($code),$addform);
   }

   $author='';
   $comment='';
   $email='';
   if (isset($_POST['author'])){$author=$_POST['author'];}
   if (isset($_POST['comment'])){$comment=$_POST['comment'];}
   if (isset($_POST['email'])){$email=$_POST['email'];}

   $addform=str_replace('{FORM_AUTHOR}',$author,$addform);
   $addform=str_replace('{FORM_COMMENT}',$comment,$addform);
   $addform=str_replace('{FORM_EMAIL}',$email,$addform);

   $wrapper=str_replace('{full_story}',SkinFullNewsArticle($article,$fullnewsarticletpl),$wrapper);
   $wrapper=str_replace('{short_story}',SkinNewsArticle($article,$newsarticletpl),$wrapper);

   $comcode='';
   if (count($comments)>0)
   {
   foreach ($comments as $item)
   {
    $temp=$commenttpl;
    $temp=str_replace('{author}',$item['author'],$temp);
    $item['date']=DecodeTime($item['date']);
    $temp=str_replace('{date}',$item['date'],$temp);
    $temp=str_replace('{comment}',$item['comment'],$temp);
    $comcode.=$temp;
   }
   }

   $wrapper=str_replace('{comments}',$comcode,$wrapper);
   $formlink=$thispage.'?xnewsaction=addcomment&amp;newsarch='.$newsarch.'&amp;newsid='.$newsid;
   $wrapper=str_replace('{add_comment_form}',$addform,$wrapper);
   $wrapper=str_replace('{form_action}',$formlink,$wrapper);
   $wrapper=str_replace('{script_url}',$script['paths']['url'],$wrapper);
   $wrapper=str_replace('{template}',$template,$wrapper);
   $wrapper=str_replace('{HTML_ON}',$script['comments']['html'],$wrapper);
   $wrapper=str_replace('{BBCODE_ON}',$script['comments']['bbcode'],$wrapper);
   $len='';
   if ($script['comments']['messagelength']=="0"){$len='unlimited';}else{$len=$script['comments']['messagelength'];}
   $wrapper=str_replace('{MSG_LENGTH}',$len,$wrapper);

   $pagination=GeneratePaginationLinks($newsarch,$newsid,25,$range,$thispage);
   $wrapper=str_replace('{pagination}',$pagination,$wrapper);
   $wrapper=str_replace('{emoticons}',GenerateEmoticonList('',15),$wrapper);

   if (isset($_COOKIE['xusername']) && isset($_COOKIE['xpassword']))
   {
    if (ValidateLogin($_COOKIE['xusername'],$_COOKIE['xpassword'])==1)
    {
     $part1=substr($wrapper,0,strpos($wrapper,"<!--NICKFIELD//-->"));
     $part2=substr($wrapper,strpos($wrapper,'<!--ENDNICKFIELD//-->')+21);
     $wrapper=$part1.'<input type="hidden" name="author" value="'.$_COOKIE['xusername'].'">'.$_COOKIE['xusername'].$part2;
     $wrapper=str_replace("{loginout}",'<a href="#" onclick="window.open(\''.$script['paths']['url'].'session.php?xnewsaction=logout\', \'remote\', \'width=640,height=250\');return false;">$__logout</a>',$wrapper);
    }else
    {
      $wrapper=str_replace("{loginout}",'<a href="#" onclick="window.open(\''.$script['paths']['url'].'session.php?xnewsaction=login\', \'remote\', \'width=640,height=250\');return false;">$__login</a>',$wrapper);
    }
   }else
   {
      $wrapper=str_replace("{loginout}",'<a href="#" onclick="window.open(\''.$script['paths']['url'].'session.php?xnewsaction=login\', \'remote\', \'width=640,height=250\');return false;">$__login</a>',$wrapper);
   }
   return $wrapper;
}

function SkinLoginPage($template,$postvar,$error,$action,$custom='')
{
  require("config.inc.php");
   $wrapper=file_get_contents($script['paths']['file']."templates/$template/login.html");
   if ($error==0)
   {
      $wrapper=str_replace('{message}',$custom,$wrapper);
   }else
   {
      $wrapper=str_replace('{message}','$__msg_loginwrong',$wrapper);
   }
   $wrapper=str_replace('{message}',$message,$wrapper);
   $wrapper=str_replace('{script_url}',$script['paths']['url'],$wrapper);
   $wrapper=str_replace('{template}',$template,$wrapper);
   $wrapper=str_replace('{form-action}',$action,$wrapper);
   if (empty($postvar)){$wrapper=str_replace('{form-fields}','',$wrapper);}else
   {
    $fields='';
    foreach (array_keys($postvar) as $i=>$key)
    {
      if ($key!='xuser' && $key!='xpass')
      $fields.='<input type="hidden" name="'.$key.'" value="'.$postvar[$key].'">';
    }
    $wrapper=str_replace('{form-fields}',$fields,$wrapper);
   }
   return $wrapper;
}

function SkinMessage($message,$template)
{
   require("config.inc.php");
   $wrapper=file_get_contents($script['paths']['file']."templates/$template/message.html");
   $wrapper=str_replace('{message}',$message,$wrapper);
   $wrapper=str_replace('{script_url}',$script['paths']['url'],$wrapper);
   $wrapper=str_replace('{template}',$template,$wrapper);
   return $wrapper;
}

function ApplyLanguage($input,$mode)
{
   require("config.inc.php");
   $language_file=$script['paths']['file']."language/".$script['system']['language']."/language".$mode.".php";
   include($language_file);
   $lang_keys=array_keys($lng);
   foreach ($lang_keys as $lang_key)
   {
    $rep='$__'.$lang_key;
    $dat=urldecode($lng[$lang_key]);
    $input=str_replace($rep,$dat,$input);
   }
   return $input;
}

function LanguageField($field,$mode='_cp')
{
   require("config.inc.php");
   $language_file=$script['paths']['file']."language/".$script['system']['language']."/language$mode.php";
   include($language_file);
   return $lng[$field];
}


function GenerateLanguageMenu()
{
   require("config.inc.php");
   $language_root=$script['paths']['file']."language/";
   $handle=dir($language_root);
   $code='';
   while (false !== ($item = $handle->read()))
   {
    $language_dir=$language_root.$item;
    if (is_dir($language_dir) && $item!='.' && $item!='..')
     {
     if ($item==$script['system']['language'])
     {
      $code.='<option selected value="'.$item.'">'.$item.'</option>';
     }else
     {
      $code.='<option value="'.$item.'">'.$item.'</option>';
     }
     }
   }
   $handle->close();
return $code;
}






//print ApplyLanguage("","_cp");

//$pattern[0]=array(1=>'{USER_NICK}',2=>'SiriusBlack');


//print ShowActionPage("home",$pattern);


?>